package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.utils.Constant;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:社交回避及苦恼量表
 * @date 2021/7/20 15:55
 */
public class SADScale extends BaseScale{

    public SADScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {
        //得分
        int score = 0;
        //社交回避分量表得分
        int score1 = 0;
        //社交苦恼分量表
        int score2 = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (i == 1 || i == 3 || i == 7 || i == 8 || i == 12 || i == 16 || i == 17 || i == 18 || i == 20|| i == 21 || i == 23 || i == 24 || i == 25 || i == 26) {
                if (i == 1 || i == 7 || i == 12 || i == 17 || i == 20 || i == 23 || i == 25) {
                    if (jsonObject1.getString("checkItems").equals("是")) {
                        score1 += 1;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("否")) {
                        score1 += 1;
                    }
                }
            }else{
                if (i == 4 || i == 9 || i == 10 || i == 13 || i == 15 || i == 19 || i == 22) {
                    if (jsonObject1.getString("checkItems").equals("是")) {
                        score2 += 1;
                    }
                } else {
                    if (jsonObject1.getString("checkItems").equals("否")) {
                        score2 += 1;
                    }
                }
            }
        }
        score = score1 + score2;
        Map<String, String> resultMap = new LinkedHashMap<>();
        resultMap.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        //根据得分判断
        if (score < 13){
            resultMap.put("社交状态", "个体表现正常，没有这方面问题");
            resultJson.put("社交状态", "个体表现正常，没有这方面问题");
        }else if (score >= 13 && score < 18){
            resultMap.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
            resultJson.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
        }else if (score >= 18){
            resultMap.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
            resultJson.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
        }
        Map<String, String> resultMap1 = new LinkedHashMap<>();
        resultMap1.put("回避分量表的分数", String.valueOf(score1));
        resultJson.put("回避分量表的分数", String.valueOf(score1));
        //根据得分判断
        if (score1 < 7){
            resultMap1.put("社交状态", "个体表现正常，没有这方面问题");
            resultJson.put("社交状态", "个体表现正常，没有这方面问题");
        }else if (score1 >= 7 && score1 < 10){
            resultMap1.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
            resultJson.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
        }else if (score1 >= 10){
            resultMap1.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
            resultJson.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
        }
        //得分列表
        Map<String, String> resultMap2 = new LinkedHashMap<>();
        resultMap2.put("焦虑分量表的分数", String.valueOf(score2));
        resultJson.put("焦虑分量表的分数", String.valueOf(score2));
        //根据得分判
        if (score2 < 8){
            resultMap2.put("社交状态", "个体表现正常，没有这方面问题");
            resultJson.put("社交状态", "个体表现正常，没有这方面问题");
        }else if (score2 >= 8 && score2 < 11){
            resultMap2.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
            resultJson.put("社交状态", "个体在这方面可能存在一定程度的问题，需要接受进一步的专业人员的检查");
        }else if (score2 >= 11){
            resultMap2.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
            resultJson.put("社交状态", "存在这方面的问题，需要接受专业的帮助");
        }
        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap);
        resultMapList.add(resultMap1);
        resultMapList.add(resultMap2);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",Constant.SHEET_NAME_SAD);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
